// CiperFileDlg.cpp :  
//

#include "stdafx.h"
#include "CiperFile.h"
#include "CiperFileDlg.h"

#include <io.h>				// ϰ
#include <WinCrypt.h>		// ȣȭ

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CCiperFileDlg ȭ 




CCiperFileDlg::CCiperFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCiperFileDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCiperFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT_FILE, m_File);
	DDX_Control(pDX, IDC_EDIT_PASS, m_Pass);
}

BEGIN_MESSAGE_MAP(CCiperFileDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_ENCODE, OnBnClickedEncode)
	ON_BN_CLICKED(IDC_DECODE, OnBnClickedDecode)
	ON_BN_CLICKED(IDC_FILE, OnBnClickedFile)
END_MESSAGE_MAP()


// CCiperFileDlg ޽ ó

BOOL CCiperFileDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	//  ȭ   մϴ.  α׷  â ȭ ڰ ƴ 쿡
	//  ӿũ  ۾ ڵ մϴ.
	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	// TODO: ⿡ ߰ ʱȭ ۾ ߰մϴ.

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

// ȭ ڿ ּȭ ߸ ߰   ׸
//  Ʒ ڵ尡 ʿմϴ. /  ϴ MFC  α׷ 쿡
//  ӿũ  ۾ ڵ մϴ.

void CCiperFileDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Ŭ̾Ʈ 簢   ϴ.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		//  ׸ϴ.
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ڰ ּȭ â  ȿ Ŀ ǥõǵ ýۿ
//   Լ ȣմϴ.
HCURSOR CCiperFileDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//  ư Ŭ 
void CCiperFileDlg::OnBnClickedFile()
{
	// ϼâ 
	CFileDialog	fDlg(TRUE, 
				"", 
				NULL, 
				OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT, 
				"(*.*)|*.*");

	// ϼâ 
	fDlg.DoModal();

	// ̸ ؽƮڽ  ϸ ǥ
	m_File.SetWindowText(fDlg.GetPathName());

}

// ȣȭ ư Ŭ 
void CCiperFileDlg::OnBnClickedEncode()
{

	BYTE	*bBuff;
	DWORD	dwFileLen;
	CString	csFile;
	FILE	*pFile;

	m_File.GetWindowText(csFile);
	
	//   ̳ʸ  
	pFile = fopen(csFile, "rb");
	if(!pFile)
	{
		AfxMessageBox(" ");
		return;
	}

	dwFileLen = _filelength(fileno(pFile));
	bBuff = new BYTE [dwFileLen];

	//  о ۿ 
	fread(bBuff, 1, dwFileLen, pFile);
	fclose(pFile);

	HCRYPTPROV	hProv;
	HCRYPTHASH	hHash;
	HCRYPTKEY	hKey;
	CString		csPass;

	m_Pass.GetWindowText(csPass);

	// CSP(Crystographic Service Provider) ڵ 
	if(!CryptAcquireContext(&hProv, NULL, MS_ENHANCED_PROV, PROV_RSA_FULL, 0))
	{
		if(!CryptAcquireContext(&hProv, NULL, MS_ENHANCED_PROV, PROV_RSA_FULL, CRYPT_NEWKEYSET))
		{
			AfxMessageBox("ȣȭ о");
			return;
		}
	}

	// ؽ 
	CryptCreateHash(hProv, CALG_SHA, 0, 0, &hHash);
	// ؽ  
	CryptHashData(hHash, (BYTE*)(LPCTSTR)csPass, csPass.GetLength(), 0);
	// Ű 	
	CryptDeriveKey(hProv, CALG_RC4, hHash, 0x0080*0x10000, &hKey);
	// ȣȭ	
	CryptEncrypt(hKey, 0, TRUE, 0, bBuff, &dwFileLen, dwFileLen);
	// ؽ ֱ
	CryptDestroyHash(hHash);
	// CSP ڵ Ǯֱ
	CryptReleaseContext(hProv, 0);

	csFile += ".CPR";
	
	//   ǥ
	CFileDialog	fDlg(FALSE, "", csFile);

	if(fDlg.DoModal() == IDOK)
	{
		// ȣȭ  ϱ
		pFile = fopen(fDlg.GetPathName(), "wb");
		fwrite(bBuff, 1, dwFileLen, pFile);
		fclose(pFile);
	}

	//  
	delete [] bBuff;

}

// ȣȭ ư Ŭ 
void CCiperFileDlg::OnBnClickedDecode()
{
	BYTE	*bBuff;
	DWORD	dwFileLen;
	CString	csFile;
	FILE	*pFile;

	m_File.GetWindowText(csFile);
	
	//   ̳ʸ  
	pFile = fopen(csFile, "rb");
	if(!pFile)
	{
		AfxMessageBox(" ");
		return;
	}

	dwFileLen = _filelength(fileno(pFile));
	bBuff = new BYTE [dwFileLen];

	//  о ۿ 
	fread(bBuff, 1, dwFileLen, pFile);
	fclose(pFile);

	HCRYPTPROV	hProv;
	HCRYPTHASH	hHash;
	HCRYPTKEY	hKey;
	CString		csPass;

	m_Pass.GetWindowText(csPass);

	// CSP(Crystographic Service Provider) ڵ 
	if(!CryptAcquireContext(&hProv, NULL, MS_ENHANCED_PROV, PROV_RSA_FULL, 0))
	{
		if(!CryptAcquireContext(&hProv, NULL, MS_ENHANCED_PROV, PROV_RSA_FULL, CRYPT_NEWKEYSET))
		{
			AfxMessageBox("ȣȭ о");
			return;
		}
	}

	// ؽ 
	CryptCreateHash(hProv, CALG_SHA, 0, 0, &hHash);
	// ؽ  
	CryptHashData(hHash, (BYTE*)(LPCTSTR)csPass, csPass.GetLength(), 0);
	// Ű 	
	CryptDeriveKey(hProv, CALG_RC4, hHash, 0x0080*0x10000, &hKey);
	// ȣȭ
	CryptDecrypt(hKey, 0, TRUE, 0, bBuff, &dwFileLen);
	// ؽ ֱ
	CryptDestroyHash(hHash);
	// CSP ڵ Ǯֱ
	CryptReleaseContext(hProv, 0);

	//   ǥ
	CFileDialog	fdlg(FALSE, "", csFile);

	if(fdlg.DoModal() == IDOK)
	{
		// ȣȭ  ϱ
		pFile = fopen(fdlg.GetPathName(), "wb");
		fwrite(bBuff, 1, dwFileLen, pFile);
		fclose(pFile);
	}

	//  
	delete [] bBuff;


}